#
AC_ARG_ENABLE([debug],
- [ --enable-debug include debugging symbols and features],
+ [AS_HELP_STRING([--enable-debug],
+ [include debugging symbols and code paths])],
[debug=$enableval],
[debug=no])
AC_ARG_ENABLE([double-precision],
- [ --enable-double-precision use doubles instead of floats],
+ [AS_HELP_STRING([--enable-double-precision],
+ [use doubles instead of floats])],
[double_precision=$enableval],
[double_precision=no])
AC_ARG_ENABLE([profile],
- [ --enable-profile make a binary with code profiling instructions],
+ [AS_HELP_STRING([--enable-profile],
+ [make a binary with code profiling instructions])],
[profile=$enableval],
[profile=no])
AC_ARG_ENABLE([extra-warnings],
- [ --enable-extra-warnings make the gcc compiler give more warnings],
+ [AS_HELP_STRING([--enable-extra-warnings],
+ [make the gcc compiler give more warnings])],
[extra_warnings=$enableval],
[extra_warnings=no])
+AC_ARG_ENABLE([link-sh],
+ [AS_HELP_STRING([--enable-link-sh],
+ [give the executable fewer direct dependencies])],
+ [link_sh=$enableval],
+ [link_sh=no])
+
AC_ARG_ENABLE([clock_gettime],
- [ --enable-clock_gettime use clock_gettime() instead of SDL_GetTicks()],
+ [AS_HELP_STRING([--enable-clock_gettime],
+ [use clock_gettime() instead of SDL_GetTicks()])],
[clock_gettime=$enableval],
[clock_gettime=no])
AC_ARG_ENABLE([threads],
- [ --enable-threads use threads for concurrency where appropriate],
+ [AS_HELP_STRING([--enable-threads],
+ [use threads for concurrency where appropriate])],
[threads=$enableval],
[threads=no])
-AC_ARG_ENABLE([gtk],
- [ --enable-gtk enable GTK+ modal dialogs],
- [gtk=$enableval],
- [gtk=no])
-
-AC_ARG_ENABLE([qt4],
- [ --enable-qt4 enable QT modal dialogs],
- [qt4=$enableval],
- [qt4=no])
+AC_ARG_WITH([gui-toolkit],
+ [AS_HELP_STRING([--with-gui-toolkit=ARG],
+ [possible values: none (default), gtk, qt4])],
+ [gui_toolkit=$withval],
+ [gui_toolkit=none])
if test x$debug = xyes
CXXFLAGS="$CXXFLAGS -Wextra -Wno-unused-parameter"
fi
+AM_CONDITIONAL([LINK_SH], [test x$link_sh = xyes])
+
if test x$threads = xyes
then
AC_DEFINE([USE_THREADS], 1,
[Define to 1 if you want to use threads when applicable.])
fi
-if test x$gtk = xyes
+if test x$gui_toolkit = xgtk
then
AC_DEFINE([USE_GTK], 1,
[Define to 1 if you want to use GTK+ modal dialogs.])
-elif test x$qt4 = xyes
+elif test x$gui_toolkit = xqt4
then
AC_DEFINE([USE_QT4], 1,
[Define to 1 if you want to use QT4 modal dialogs.])
AC_MSG_WARN([Missing liblua ($website)])])
##### GTK+ 2.0 #####
-if test x$gtk = xyes
+if test x$gui_toolkit = xgtk
then
website="http://www.gtk.org/"
PKG_CHECK_MODULES([GTK], [gtk+-2.0],
fi
##### QT4 #####
-if test x$qt4 = xyes
+if test x$gui_toolkit = xqt4
then
website="http://qt.nokia.com/"
- PKG_CHECK_MODULES([QT], [QtGui],
- [LIBS="$LIBS $QT_LIBS"
- CFLAGS="$CFLAGS $QT_CFLAGS"
- CXXFLAGS="$CXXFLAGS $QT_CFLAGS"],
+ PKG_CHECK_MODULES([QT4], [QtGui],
+ [LIBS="$LIBS $QT4_LIBS"
+ CFLAGS="$CFLAGS $QT4_CFLAGS"
+ CXXFLAGS="$CXXFLAGS $QT4_CFLAGS"],
[missing=yes
- AC_MSG_WARN([Missing QT ($website)])])
+ AC_MSG_WARN([Missing QT4 ($website)])])
fi
if test x$missing = xyes
PVERSION="${VERSION_MAJOR:-0}.${VERSION_MINOR:-0}.${VERSION_REVISION:-0}.0"
AC_SUBST([PVERSION])
+if githead=$(git log -n1 --date=short --pretty=format:"%h (%ad)")
+then
+ AC_DEFINE_UNQUOTED([YOINK_GITHEAD], ["$githead"],
+ [Define to the git commit currently checked out.])
+fi
+
#
# Create the build files.
--- /dev/null
+#!/bin/sh
+
+#
+# Yoink
+# Execute this file to link the executable with fewer direct dependencies.
+#
+# You shouldn't call this directly; instead, use the configure script's
+# --enable-link-sh option and run make normally. This isn't enabled by
+# default because there is the potential for runtime linking problems. If
+# you have a newer version of GCC, you should prefer the --as-needed linker
+# flag over this method, though they both should accomplish the same thing.
+#
+
+# link.sh -- try linking Vim with different sets of libraries, finding the
+# minimal set for fastest startup. The problem is that configure adds a few
+# libraries when they exist, but this doesn't mean they are needed for Vim.
+#
+# Author: Bram Moolenaar
+# Last change: 2006 Sep 26
+# License: Public domain
+#
+# Warning: This fails miserably if the linker doesn't return an error code!
+#
+# Otherwise this script is fail-safe, falling back to the original full link
+# command if anything fails.
+
+echo "$LINK " >link.cmd
+exit_value=0
+
+#
+# If .link/link.sed already exists, use it. We assume a previous run of
+# link.sh has found the correct set of libraries.
+#
+if test -f .link/link.sed; then
+ echo "link.sh: The file '.link/link.sed' exists, which is going to be used now."
+ echo "link.sh: If linking fails, try deleting the .link/link.sed file."
+ echo "link.sh: If this fails too, try creating an empty .link/link.sed file."
+else
+
+# If linking works with the full link command, try removing some libraries,
+# that are known not to be needed on at least one system.
+# Remove .link/pathdef.c if there is a new link command and compile it again.
+# There is a loop to remove libraries that appear several times.
+#
+# Notes:
+# - Can't remove Xext; It links fine but will give an error when running gvim
+# with Motif.
+# - Don't remove the last -lm: On HP-UX Vim links OK but crashes when the GTK
+# GUI is started, because the "floor" symbol could not be resolved.
+#
+ cat link.cmd
+ if sh link.cmd; then
+ mkdir -p .link
+ touch .link/link.sed
+ cp link.cmd linkit.sh
+ for libname in atk-1.0 cairo fontconfig freetype gdk-x11-2.0 gio-2.0 glib-2.0 gmodule-2.0 ogg pango-1.0 pangocairo-1.0 pangoft2-1.0 vorbis; do
+ cont=yes
+ while test -n "$cont"; do
+ if grep "l$libname " linkit.sh >/dev/null; then
+ if test ! -f link1.sed; then
+ echo "link.sh: OK, linking works, let's try removing a few libraries."
+ echo "link.sh: See .link/link.log for details."
+ rm -f .link/link.log
+ fi
+ echo "s/-l$libname *//" >link1.sed
+ sed -f .link/link.sed <link.cmd >linkit2.sh
+ sed -f link1.sed <linkit2.sh >linkit.sh
+ # keep the last -lm
+ if test $libname != "m" || grep "lm " linkit.sh >/dev/null; then
+ echo "link.sh: Trying to remove the $libname library..."
+ cat linkit.sh >>.link/link.log
+ # Redirect this link output, it may contain error messages which
+ # should be ignored.
+ if sh linkit.sh >>.link/link.log 2>&1; then
+ echo "link.sh: We don't need the $libname library!"
+ cat link1.sed >>.link/link.sed
+ else
+ echo "link.sh: We DO need the $libname library."
+ cont=
+ cp link.cmd linkit.sh
+ fi
+ else
+ cont=
+ cp link.cmd linkit.sh
+ fi
+ else
+ cont=
+ cp link.cmd linkit.sh
+ fi
+ done
+ done
+ if test ! -f link1.sed; then
+ echo "link.sh: Linked fine, no libraries can be removed"
+ touch link3.sed
+ fi
+ else
+ exit_value=$?
+ fi
+fi
+
+#
+# Now do the real linking.
+#
+if test -s .link/link.sed; then
+ echo "link.sh: Using .link/link.sed file to remove a few libraries"
+ sed -f .link/link.sed <link.cmd >linkit.sh
+ cat linkit.sh
+ if sh linkit.sh; then
+ exit_value=0
+ echo "link.sh: Linked fine with a few libraries removed"
+ else
+ exit_value=$?
+ echo "link.sh: Linking failed, making .link/link.sed empty and trying again"
+ mv -f .link/link.sed link2.sed
+ touch .link/link.sed
+ fi
+fi
+if test -f .link/link.sed -a ! -s .link/link.sed -a ! -f link3.sed; then
+ echo "link.sh: Using unmodified link command"
+ cat link.cmd
+ if sh link.cmd; then
+ exit_value=0
+ echo "link.sh: Linked OK"
+ else
+ exit_value=$?
+ if test -f link2.sed; then
+ echo "link.sh: Linking doesn't work at all, removing .link/link.sed"
+ rm -f .link/link.sed
+ fi
+ fi
+fi
+
+#
+# cleanup
+#
+rm -f link.cmd linkit.sh link1.sed link2.sed link3.sed linkit2.sh
+
+#
+# return an error code if something went wrong
+#
+exit $exit_value
+
}
std::cout << " Executable: " << argv[0] << std::endl
+#ifdef YOINK_GITHEAD
+ << " Commit: "YOINK_GITHEAD << std::endl
+#endif
<< " Version: "VERSION << std::endl
<< " Built: " << COMPILE_TIME << std::endl
<< " Compiler: "COMPILER_STRING << std::endl
$(ENDLIST)
if WIN32
-
yoink_SOURCES += yoink.rc
-
.rc.o:
$(WINDRES) -o $@ -i $<
-
else
-
YOINK_ENVIRONMENT = YOINK_DATADIR="$(top_srcdir)/data"
-
run: all
$(YOINK_ENVIRONMENT) ./yoink $(YOINK_OPTS)
debug: all
$(YOINK_ENVIRONMENT) gdb ./yoink
+endif
+
+if LINK_SH
+yoink$(EXEEXT): $(yoink_OBJECTS) $(yoink_DEPENDENCIES)
+ @rm -f yoink$(EXEEXT)
+ @LINK="$(CXXLINK) $(yoink_OBJECTS) $(yoink_LDADD) $(LIBS)"\
+ sh $(top_srcdir)/link.sh
+clean-local:
+ rm -rf .link
endif